﻿/*******************************************************************
* Autoren:                                                         *
*    Tim Pack                                                      *
*    Fabian Daugs						   *
*    für die						   	   *
*    Bundeszentrale für gesundheitliche Aufklärung (BZgA)  	   *
*    zur freien Verwendung und Veränderung mit der...		   *
*    ::: Toolbox zur Website-Evaluation :::			   *
*    https://www.bzga.de/forschung/cahpot/toolbox/		   *
*    Anregungen bitte an: toolbox@bzga.de			   *
********************************************************************/


(function () {
    // Diese Variablen bestimmen gemäß ihrer Benennung
    // die Eigenschaften des jeweiligen GUI-Elements

    // Der Link der geöffnet wird wenn der Nutzer auf "Jetzt teilnehmen" drückt.
    var umfrage_link = "https://limesurvey.psychfactors.com/index.php/453474?newtest=Y&lang=de";

    // Texte des Survey Widgets
    var survey_widget_titel = "Sind Sie mit unserer Website zufrieden?"
    var survey_widget_text = "Diese Umfrage hilft uns diese Website für Sie zu verbessern! Vielen Dank für Ihre Teilnahme."

    // Farben der Fenster
    var hintergrund_farbe = "white";
    var mobile_knopf_farbe = "#326cc9";

    // Farben der Buttons
    var teilnehmen_knopf_farbe = "#A6FF4D";
    var teilnehmen_knopf_farbe_schrift = "#558122";
    var ablehnen_knopf_farbe = "#FE6464";
    var ablehnen_knopf_farbe_schrift = "#913434";
    var später_knopf_farbe = "#fe9d64";
    var später_knopf_farbe_schrift = "#85553a";
 
    // Die Farbe des jeweiligen GUI-Elements in einem definiertem Zustand
    // active = Button wird gedrückt
    // hover = Maus ist über Button
    var teilnehmen_knopf_farbe_hover = lightenDarkenColor(teilnehmen_knopf_farbe,50);
    var teilnehmen_knopf_farbe_active = lightenDarkenColor(teilnehmen_knopf_farbe,-50);
    var später_knopf_farbe_hover = lightenDarkenColor(später_knopf_farbe,50);
    var später_knopf_farbe_active = lightenDarkenColor(später_knopf_farbe,-50);
    var ablehnen_knopf_farbe_hover = lightenDarkenColor(ablehnen_knopf_farbe,50);
    var ablehnen_knopf_farbe_active = lightenDarkenColor(ablehnen_knopf_farbe,-50);

    var mobile_knopf_farbe_hover = lightenDarkenColor(mobile_knopf_farbe,50);
    var mobile_knopf_farbe_active = lightenDarkenColor(mobile_knopf_farbe,-20);

    //Der gesamte HTML Body des survey Widgets
    var htmlBody = '<div class="survey-widget"> <div class="survey-box survey-hidden"><div id="survey-close" class="close-thik"></div><div class="survey-box-title"><h3>Sind Sie mit unserer Website zufrieden?</h3> Diese Umfrage hilft uns diese Website für Sie zu verbessern! Vielen Dank für Ihre Teilnahme. </div><div class="survey-box-btn-yes">Jetzt teilnehmen</div><div class="survey-box-btn-mb">Später teilnehmen</div><div class="survey-box-btn-no">Nicht teilnehmen</div></div><div class="survey-btn-mobile"> <a href="#" class="survey-btn-mobile-round"><svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px" viewBox="0 0 1920 1080" style="enable-background:new 0 0 1920 1080;" xml:space="preserve"><style type="text/css">.st0{display:none;}.st1{display:inline;fill:#00BF10;stroke:#000000;stroke-miterlimit:10;}.st2{opacity:0.4;}.st3{fill:none;stroke:#FFFFFF;stroke-width:16;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:1.5;}.st4{fill:#FFFFFF;}</style><g id="Layer_2" class="st0"><rect x="-38" y="-16" class="st1" width="2270" height="1316"/></g><g id="Layer_1"><g id="Layer_1_1_"><g transform="matrix(1,0,0,1,-3826.82,-995.182)" class="st2"><g transform="matrix(1,0,0,1,2011.53,0)"><g transform="matrix(1.04751,0,0,1.04751,-97.8469,-48.8022)"><g transform="matrix(0.681926,0,0,0.606802,-785.279,393.088)"><rect x="4962.4" y="1030.8" class="st3" width="288.4" height="138.3"/></g><g transform="matrix(1,0,0,1,-2011.53,0)"><path class="st3" d="M4871.1,1060.6h185.7v957.5h-696.5v-957.5h185.7"/></g><g transform="matrix(1,0,0,1,-12.6432,-0.574477)"><g transform="matrix(1,0,0,1,-2005.84,-2.12543)"><path class="st3" d="M4574.1,1243.1h-116V1381h138.2v-77"/></g><g transform="matrix(0.493948,0,0,0.493948,-45.0809,502.89)"><path class="st3" d="M5124.9,1593.5l78.5,93.2l174.4-199.9"/></g></g><g transform="matrix(1,0,0,1,-12.6432,9.87544)"><g transform="matrix(1,0,0,1,-2005.84,-2.12543)"><path class="st3" d="M4574.1,1464.4h-116v137.9h138.2v-77"/></g><g transform="matrix(0.493948,0,0,0.493948,-45.0809,502.89)"><path class="st3" d="M5124.9,2041.5l78.5,93.2l174.4-199.9"/></g></g><g transform="matrix(1,0,0,1,-2018.48,18.1999)"><rect x="4458.1" y="1685.8" class="st3" width="138" height="138"/></g><g transform="matrix(1,0,0,1.64286,-2011.53,-639.123)"><rect x="4686.2" y="1302.6" class="st4" width="256.6" height="46.7"/></g><g transform="matrix(1,0,0,1.64286,-2011.53,-628.59)"><rect x="4686.2" y="1438.5" class="st4" width="256.6" height="46.7"/></g><g transform="matrix(1,0,0,1.64286,-2011.53,-649.573)"><rect x="4686.2" y="1167.9" class="st4" width="256.6" height="46.7"/></g></g></g></g><g><path class="st4" d="M279.7,562.6c0,31-9.5,54.6-28.3,71.2s-46.7,24.6-83.4,24.6s-64.4-8.3-83.2-24.8c-18.8-16.5-28.3-40.1-28.3-71V402.7h65V559c0,17.4,3.6,30.3,10.9,38.9c7.2,8.4,19.1,12.8,35.5,12.8c16.2,0,27.9-4.1,35.5-12.2c7.4-8.3,11.2-21.4,11.2-39.5V402.7h65v159.9H279.7z"/><path class="st4" d="M602.8,653.2h-64.3V485.4L492,594.3h-44.6l-46.5-108.9v167.8h-61V402.7H415l56.3,125.6l56.2-125.6h75.1v250.5H602.8z"/><path class="st4" d="M846.2,451.1H731v46.7h106.8v48.4H731v107h-64.3V402.7h179.5V451.1z"/><path class="st4" d="M1132.1,653.2h-78.9l-68.2-91.8h-30v91.8h-64.3V402.7h108.4c14.8,0,27.6,0.9,38.3,2.6c10.7,1.7,20.7,5.3,30,10.9c9.5,5.7,16.9,12.9,22.4,21.7c5.5,8.8,8.3,20.2,8.3,33.6c0,18.4-4.3,33.6-12.9,45.3c-8.6,11.7-20.8,21.4-36.7,29.1L1132.1,653.2z M1031.3,479.4c0-6.2-1.2-11.7-3.8-16.2s-7.1-8.1-13.3-10.7c-4.3-1.7-9.5-2.9-15.3-3.3c-5.9-0.3-12.6-0.5-20.3-0.5h-23.4v67.5h19.8c10.3,0,19-0.5,25.8-1.6c6.9-1,12.8-3.3,17.6-6.9c4.5-3.4,7.8-7.2,9.8-11.5C1030.3,492.1,1031.3,486.4,1031.3,479.4z"/><path class="st4" d="M1391.9,653.2h-66.7l-17.4-50.7h-92.7l-17.4,50.7h-65.1l92.5-250.5h74.4L1391.9,653.2z M1292.2,556.6l-30.8-89.8l-30.8,89.8H1292.2z"/><path class="st4" d="M1649.5,638.9c-11.2,4.3-26,8.8-44.6,13.1c-18.6,4.3-37,6.5-55.3,6.5c-42.6,0-76-11.5-100.1-34.8c-24.1-23.1-36.2-55.1-36.2-96c0-38.9,12.2-70.3,36.5-94.1c24.3-24,58.2-35.8,101.8-35.8c16.5,0,32.2,1.6,47,4.5c15,2.9,31.5,9,49.8,17.7v58.8h-7.2c-3.1-2.4-7.8-5.7-13.8-10c-6-4.3-11.9-7.9-17.6-11c-6.5-3.6-14.1-6.7-22.7-9.3c-8.6-2.6-17.9-3.8-27.7-3.8c-11.4,0-21.9,1.7-31.2,5c-9.3,3.4-17.7,8.4-25.2,15.5c-7.1,6.7-12.6,15.3-16.7,25.7c-4.1,10.3-6.2,22.4-6.2,35.8c0,27.7,7.4,48.9,22.1,63.6c14.6,14.6,36.4,22.1,65.1,22.1c2.4,0,5.2,0,8.1-0.2s5.7-0.3,8.1-0.5v-49.1h-50v-47.4h115.6v123.7H1649.5z"/><path class="st4" d="M1888.7,653.2h-181.3V402.7h181.3v48.4h-117v43.2h108.6v48.4h-108.6v61.9h117V653.2z"/></g></g></g></svg> </a> </div></div>';
    //Das gesamte CSS-Stylesheet des survey Widgets mit eingebundenen Variablen
    var cssBody = '.survey-widget{font-family: Verdana, Geneva, sans-serif;}.survey-box{z-index: 9999; position: fixed; bottom: 0px; right: 0px; background: '+ hintergrund_farbe +'; border-radius: 2px; display: inline-block; text-align: center; width: 100%; margin: 0rem; box-shadow: 1px 3px 5px rgba(0,0,0,0.24), 1px 3px 6px rgba(0,0,0,0.48); transition: all 0.3s cubic-bezier(.25,.8,.25,1); animation-name: bounceIn; animation-duration: 450ms; animation-timing-function: linear; animation-fill-mode: forwards;}.survey-box-title{margin: 25px 10px;}.survey-box-btn-yes{background: '+ teilnehmen_knopf_farbe +'; color: '+ teilnehmen_knopf_farbe_schrift +';}.survey-box-btn-no{background: '+ ablehnen_knopf_farbe +'; color: '+ ablehnen_knopf_farbe_schrift +';}.survey-box-btn-mb{background: '+ später_knopf_farbe +'; color: '+ später_knopf_farbe_schrift +';}.survey-box-btn-yes, .survey-box-btn-no, .survey-box-btn-mb{display: block; -webkit-user-select: none; user-select: none; cursor: pointer; margin: .5rem; line-height: 50px; text-align: center; border-radius: 5px; box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);}.survey-box-btn-yes:hover{background:'+ teilnehmen_knopf_farbe_hover +'; box-shadow: 0 3px 5px rgba(0,0,0,0.25), 0 3px 4px rgba(0,0,0,0.22);}.survey-box-btn-yes:active{background:'+ teilnehmen_knopf_farbe_active +'; color: white; box-shadow: 0 1px 3px rgba(0,0,0,0.25), 0 1px 2px rgba(0,0,0,0.22);}.survey-box-btn-mb:hover{background: '+ später_knopf_farbe_hover +'; box-shadow: 0 3px 5px rgba(0,0,0,0.25), 0 3px 4px rgba(0,0,0,0.22);}.survey-box-btn-mb:active{background: '+ später_knopf_farbe_active +'; color: white; box-shadow: 0 1px 3px rgba(0,0,0,0.25), 0 1px 2px rgba(0,0,0,0.22);}.survey-box-btn-no:hover{background: '+ ablehnen_knopf_farbe_hover +'; color: white; box-shadow: 0 3px 5px rgba(0,0,0,0.25), 0 3px 4px rgba(0,0,0,0.22);}.survey-box-btn-no:active{background:'+ ablehnen_knopf_farbe_active +'; box-shadow: 0 1px 3px rgba(0,0,0,0.25), 0 1px 2px rgba(0,0,0,0.22);}[class*="close-"]{color: #777; font: 14px/100% arial, sans-serif; position: absolute; right: 5px; text-decoration: none; text-shadow: 0 1px 0 #fff; top: 5px; margin-bottom: 10px;}.close-thik:after{content: "✖"; cursor:pointer;}#survey-close{cursor:pointer;}.survey-btn-mobile{display:inline-block; position: fixed; width:80px; height:80px; bottom: 1.5rem; right: 1.5rem; z-index: 9999; transition: all 0.3s cubic-bezier(.25,.8,.25,1); animation-name: bounceIn; animation-duration: 450ms; animation-timing-function: linear; animation-fill-mode: forwards;}.survey-btn-mobile > a{display:inline-block; width: 100%; height: 100%; line-height:50px; border: 2px solid #f5f5f5; border-radius: 50%; text-align:center; text-decoration:none; background: '+ mobile_knopf_farbe +'; box-shadow: 0 0 3px gray; font-weight:bold;}.survey-btn-mobile-round:hover{background:'+ mobile_knopf_farbe_hover +'; font-size: 1.3rem; box-shadow: 0 3px 5px rgba(0,0,0,0.25), 0 3px 4px rgba(0,0,0,0.22);}.survey-btn-mobile-round:active{background:'+ mobile_knopf_farbe_active +'; font-size: 1.3rem; box-shadow: 0 1px 3px rgba(0,0,0,0.12), 0 1px 2px rgba(0,0,0,0.24);}.survey-btn-mobile-round{padding: 0; position: relative; height: 100%;}.survey-btn-mobile-round > svg{width: 90%; height: 90%; overflow: auto; margin: auto; position: absolute; top: 0; left: 0; bottom: 0; right: 0;}.survey-btn-mobile-title{text-align: center; width: 100%; height: 100%; overflow: auto; margin: auto; position: absolute; transform: translateY(-27%); font-size: 1.4rem;}@keyframes bounceIn{0%{opacity: 0; transform: scale(0.3) translate3d(0,0,0);}50%{opacity: 0.9; transform: scale(1.1);}80%{opacity: 1; transform: scale(0.89);}100%{opacity: 1; transform: scale(1) translate3d(0,0,0);}}@media only screen and (max-width: 600px){.survey-btn-mobile{height: 60px; width: 60px;}}@media only screen and (min-width: 900px){.survey-btn-mobile{height: 90px; width: 90px;}.survey-box{bottom: 1.5rem; right: 1.5rem; width: 300px;}}@media only screen and (min-width: 1200px){.survey-btn-mobile{height: 100px; width: 100px;}}@media only screen and (min-width: 1800px){.survey-btn-mobile{height: 110px; width: 110px;}.survey-box{bottom: 1.5rem; right: 1.5rem; width: 350px;}}.survey-hidden{display:none;}'
    
    main();
    /******** Main ********/
    function main() {
        // Falls in dieser Session das Overlay  mit "Nicht teilnehmen" oder "Teilnehmen" ausgeblendet wurde
        // Wird es erst in einer neuen Session wieder geladen
        if (checkSessionStorage("survey-overlay-hide") == false) {

            /******* CSS laden *******/
            var css_link = document.createElement("style");
            css_link.innerHTML = cssBody;
            document.head.appendChild(css_link);

            /******* Survey Widget erstellen *******/
            var widget_container = document.createElement("div");
            widget_container.id = "survey-widget-container";
            widget_container.className = "survey-widget";

            /******* HTML laden *******/
            widget_container.innerHTML = htmlBody;

            document.body.appendChild(widget_container);

            // Zeigt die SurveyBox nur an wenn es kein Mobile ist oder das sessionStorage-Objekt nicht auf later steht
            if ((window.matchMedia("(min-width: 600px)").matches) && (cookieExists("survey-overlay-later") == false)) {
                document.querySelector(".survey-box").classList.toggle('survey-hidden');
                document.querySelector(".survey-btn-mobile").classList.toggle('survey-hidden');
            }
            /* Teilnehmen 
            Umfrage wird geöffnet und nicht mehr angezeigt
            */
            document.querySelector(".survey-box-btn-yes").addEventListener('click', function () {
                window.open(umfrage_link);
                // Die Umfrage wurde geöffnet und das Overlay wird in dieser Session ausgeblendet
                // Nach Ablauf der Session wird das Overlay als Button angezeigt
                setCookie("survey-overlay-later", "",28);
                setSessionStorage("survey-overlay-hide");
                document.querySelector(".survey-box").classList.add('survey-hidden');
                document.querySelector(".survey-btn-mobile").classList.add('survey-hidden');
            });
            /* Später oder "x"
            Umfrage wird "minimiert" und nur der Button angezeigt
            */
            document.querySelector(".survey-box-btn-mb").addEventListener('click', function () {
                setCookie("survey-overlay-later", "",28);
                document.querySelector(".survey-box").classList.toggle('survey-hidden');
                document.querySelector(".survey-btn-mobile").classList.toggle('survey-hidden');
            });
            document.querySelector("#survey-close").addEventListener('click', function () {
                setCookie("survey-overlay-later", "",28);
                document.querySelector(".survey-box").classList.toggle('survey-hidden');
                document.querySelector(".survey-btn-mobile").classList.toggle('survey-hidden');
            });
            /* Nicht teilnehmen 
            Umfrage wird geschlossen und in dieser Session nicht mehr angezeigt.
            In einer neuen Session wird der Button eingeblendet
            */
            document.querySelector(".survey-box-btn-no").addEventListener('click', function () {
                setCookie("survey-overlay-later", "",28);
                setSessionStorage("survey-overlay-hide");
                document.querySelector(".survey-box").classList.toggle("survey-hidden");
                document.querySelector(".survey-btn-mobile").classList.add("survey-hidden");
            });
            // Beim klick auf Button, versteck den Button und zeige die Box
            document.querySelector(".survey-btn-mobile").addEventListener('click', function () {
                document.querySelector(".survey-box").classList.toggle('survey-hidden');
                document.querySelector(".survey-btn-mobile").classList.toggle('survey-hidden');
            });
        }

    }

    // Überprüft das sessionStorage-Objekt einen angegebenen Wert hat
    function checkSessionStorage(n) {
        return (sessionStorage.surveyWidgetState == n);
    }

    // Fügt dem SessionStorage mit eine Objekt mit angegebenen Namen und Wert hinzu
    function setSessionStorage(v) {
        sessionStorage.surveyWidgetState = v;
    }

    // Liest den Cookie-String und returned den Cookie mit dem angegebenen Namen
    function cookieExists(n) {
        return (document.cookie.indexOf(n+"=") >= 0);
    }
    
        // Fügt dem Cookie-String einen Cookie mit angegbenen Namen, Wert und Ablaufzeit hinzu
    function setCookie(n, v, exdays) {
        var d = new Date();
        d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
        var expires = "expires=" + d.toUTCString();
        document.cookie = n + "=" + v + ";" + expires + ";path=/";
    }

    // Berechnet den Farbcode eine dunkleren Farbe als die Angegebene
    function lightenDarkenColor(col, amt) {
        var usePound = false;
      
        if (col[0] == "#") {
            col = col.slice(1);
            usePound = true;
        }
    
        var num = parseInt(col,16);
    
        var r = (num >> 16) + amt;
    
        if (r > 255) r = 255;
        else if  (r < 0) r = 0;
    
        var b = ((num >> 8) & 0x00FF) + amt;
    
        if (b > 255) b = 255;
        else if  (b < 0) b = 0;
    
        var g = (num & 0x0000FF) + amt;
    
        if (g > 255) g = 255;
        else if (g < 0) g = 0;
       
            var newColor = (g | (b << 8) | (r << 16)).toString(16);
        
        while( newColor.length < 6 ) newColor = "0" + newColor;
            
        return (usePound?"#":"") + newColor;
    }

})();


/*Made with ♥ in Wiehl und Köln.*/